<?php
/*
 * Copyright(c) 2011 SOFTBANK PAYMENT SERVICE Corp. All rights reserved.
 * http://www.sbpayment.jp/
 */

// in LC_Page_Shopping_LoadPaymentModule

require_once(MODULE_REALDIR . 'mdl_sps/inc/include.php');
require_once(MDL_SPS_CLASS_PATH . "LC_Mdl_SPS.php");

$objSPS =& LC_Mdl_SPS::getInstance();
$order_url = $objSPS->getUserSettings( 'url_sps_buyservice_api' );

$objSiteSess = new SC_SiteSession();
$objCartSess = new SC_CartSession();
$objCustomer = new SC_Customer();
$objDb = new SC_Helper_DB_Ex();
$arrInfo = $objDb->sfGetBasisData();

$objQuery =& SC_Query::getSingletonInstance();

$arrOrder = $objQuery->select('*', 'dtb_order', 'order_id = ?', array($order_id));
$arrOrder = $arrOrder[0];

$arrOrderDetail = $objQuery->select('*', 'dtb_order_detail', 'order_id = ?', array($order_id));

$arrPayment = $objQuery->getall("SELECT * FROM dtb_payment WHERE payment_id = ? ", array($arrOrder["payment_id"]));

// 非会員のときは cust_code に not_member+一意な文字列 を送る
($arrOrder["customer_id"] == 0) ? $arrOrder["chg_cust_code"] = NON_MEMBER_PREFIX . md5(uniqid(rand(), true)) : $arrOrder["chg_cust_code"] = $arrOrder["customer_id"];

// 送信データ生成
switch($arrPayment[0]["memo03"]) {
    case SPS_CREDIT:
        $auth_type = $objSPS->getUserSettings('type_sps_auth');
		$objQuery->update('dtb_order', array('memo03' => $auth_type), 'order_id = ?', array($order_id));
        $arrPayment[0]["chg_memo03"] = "credit"; // クレジット
        break;
	case SPS_CREDIT3D:
		$auth_type = $objSPS->getUserSettings('type_sps_auth');
		$objQuery->update('dtb_order', array('memo03' => $auty_type), 'order_id = ?', array($order_id));
        if(SC_MobileUserAgent::isMobile()) {
            $arrPayment[0]["chg_memo03"] = "credit"; // クレジット
        }else{
    		$arrPayment[0]["chg_memo03"] = "credit3d"; // 3Dセキュアクレジット
        }
		break;
    case SPS_CONVENI:
        $arrPayment[0]["chg_memo03"] = "webcvs"; // ウェブコンビニ
        break;
    case SPS_PAYEASY:
        $arrPayment[0]["chg_memo03"] = "payeasy"; // ペイジー
        break;
    case SPS_WEBMONEY:
        $arrPayment[0]["chg_memo03"] = "webmoney"; // ウェブマネー
        break;
    case SPS_YWALLET:
        $arrPayment[0]["chg_memo03"] = "yahoowallet"; // Yahoo!ウォレット
        break;
}

// データ送信先CGI 携帯端末の場合は 携帯用に飛ばす
if(SC_MobileUserAgent::isMobile()) {
    $arrBackTrace = debug_backtrace();
    $objPage = $arrBackTrace[1]['object'];
    lfSendMobileCredit($objPage, $arrOrder, $arrOrderDetail, $arrPayment, $order_url, $arrInfo);
    $objPage->sendResponse();

}else{
	lfSendPcCredit($arrOrder, $arrOrderDetail, $arrPayment, $order_url, $arrInfo);
	exit();
}

//---------------------------------------------------------------------------------------------------------------------------------------------------------

// データ送信処理(PC)
function lfSendPcCredit($arrData, $arrOrderDetail, $arrPayment, $order_url, $arrInfo) {
	$arrFirstProduct = $arrOrderDetail[0];
    $now_time = date("YmdHis");

	$arrSendData = array(
		'pay_method' => $arrPayment[0]["chg_memo03"],	// 利用する決済サービス
		'merchant_id' => $arrPayment[0]["memo01"],		// マーチャントID
		'service_id' => $arrPayment[0]["memo02"],		// サービスID
		'cust_code' => $arrData["chg_cust_code"],		// マーチャント顧客コード
		'sps_cust_no' => "",							// SPS顧客ID
		'sps_payment_no' => "",							// SPS支払方法管理番号
		'order_id' => $arrData["order_id"]. $now_time,	// マーチャント購入ID + リクエスト日時(YYYYMMDDHHMMSS)
		'item_id' => $arrFirstProduct['product_id'],	// マーチャント商品ID
		'pay_item_id' => "",
		'item_name' => LC_Util_SPS::convNgChar($arrFirstProduct['product_name']),
		'tax' => "",
		'amount' => $arrData["payment_total"],			// 金額(税込)
		'pay_type' => "0",								// 購入タイプ(固定　0:都度購入、1:継続購入)
		'auto_charge_type' => "",
		'service_type' => "0",							// サービスタイプ(固定　0:売上（購入）、1:取消（月額課金解約）)
		'div_settele' => "",
		'last_charge_month' => "",
		'camp_type' => "",
		'tracking_id' => "",
		'terminal_type' => "0",							// 顧客利用端末タイプ(可変　0:PC、1:モバイル)
		'success_url' => SUCCESS_URL,					// 決済完了時URL
		'cancel_url' => CANCEL_URL,						// 決済キャンセル時URL
		'error_url' => ERROR_URL,						// エラー時URL
		'pagecon_url' => MDL_SPS_SETTLEMENT_URL,		// 決済通知用CGI
		'free1' => $arrData["order_id"],				// マーチャント購入ID
		'free2' => "",
		'free3' => "",
		'free_csv' => "",
		'request_date' => $now_time,					// リクエスト日時(YYYYMMDDHHMMSS)
		'limit_second' => "600"							// リクエスト許容時間
	);

	// チェックサム生成
	$sps_hashcode = createCheckSum($arrData, $arrOrderDetail, $arrSendData, $arrInfo);

	$html = "<html>";
	$html .= "<body onload=\"document.form1.submit();\">\n";
//	$html .= "<body>";
	$html .= "\t<form name=\"form1\" id=\"form1\" method=\"post\" action=\"" . $order_url . "\">\n";
	foreach($arrSendData as $key => $val){
		$html .= "\t\t<input type=\"hidden\" name=\"".$key."\" value=\"".$val."\">\n";
	}

	$rowno = 1;
	foreach( $arrOrderDetail as $row => $col ){
		// 税込み価格
		$tax_in = SC_Utils_Ex::sfCalcIncTax($col['price'], $arrInfo['tax'], $arrInfo['tax_rule'] );
		// 税額
		$tax = $tax_in - $col['price'];
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_rowno[]\" value=\"". $rowno ."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_id[]\" value=\"". $col['product_id']."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_name[]\" value=\"".LC_Util_SPS::convNgChar($col['product_name'])."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_count[]\" value=\"".$col['quantity']."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_tax[]\" value=\"".$tax."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_amount[]\" value=\"" . $tax_in * $col['quantity'] . "\">\n";

		$rowno++;
	}

	// 送料
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_rowno[]\" value=\"".$rowno."\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_id[]\" value=\"no-code\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_name[]\" value=\""."送料"."\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_count[]\" value=\"1\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_tax[]\" value=\"0\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_amount[]\" value=\"".$arrData['deliv_fee']."\">\n";

	// ハッシュ
	$html .= "\t\t<input type=\"hidden\" name=\"sps_hashcode\" value=\"".$sps_hashcode."\">\n";

	$html .= "\t</form>\n";
	$html .= "</body></html>\n";

//    mb_http_output('SJIS-win');
    header("Content-Type: text/html; charset=Shift_JIS");
	echo mb_convert_encoding($html, 'sjis-win', 'UTF-8');
}

// データ送信処理(MOBILE)
function lfSendMobileCredit(&$objPage, $arrData, $arrOrderDetail, $arrPayment, $order_url, $arrInfo) {
	global $objSiteSess;
	global $objDb;
	global $arrInfo;

    $arrFirstProduct = $arrOrderDetail[0];
    $now_time = date("YmdHis");

	$arrSendData = array(
		'pay_method' => $arrPayment[0]["chg_memo03"],	// 利用する決済サービス
		'merchant_id' => $arrPayment[0]["memo01"],		// マーチャントID
		'service_id' => $arrPayment[0]["memo02"],		// サービスID
		'cust_code' => $arrData["chg_cust_code"],		// マーチャント顧客コード
		'sps_cust_no' => "",							// SPS顧客ID
		'sps_payment_no' => "",							// SPS支払方法管理番号
		'order_id' => $arrData["order_id"]. $now_time,	// マーチャント購入ID + リクエスト日時(YYYYMMDDHHMMSS)
		'item_id' => $arrFirstProduct['product_id'],	// マーチャント商品ID
		'pay_item_id' => "",
		'item_name' => LC_Util_SPS::convNgChar($arrFirstProduct['product_name']),
		'tax' => "",
		'amount' => $arrData["payment_total"],			// 金額(税込)
		'pay_type' => "0",								// 購入タイプ(固定　0:都度購入、1:継続購入)
		'auto_charge_type' => "",
		'service_type' => "0",							// サービスタイプ(固定　0:売上（購入）、1:取消（月額課金解約）)
		'div_settele' => "",
		'last_charge_month' => "",
		'camp_type' => "",
		'tracking_id' => "",
		'terminal_type' => "1",							// 顧客利用端末タイプ(可変　0:PC、1:モバイル)
		'success_url' => SUCCESS_URL . '&' . session_name() . '=' . session_id(),					// 決済完了時URL
		'cancel_url' => CANCEL_URL . '&' . session_name() . '=' . session_id(),						// 決済キャンセル時URL
		'error_url' => ERROR_URL . '&' . session_name() . '=' . session_id(),						// エラー時URL
		'pagecon_url' => MDL_SPS_SETTLEMENT_URL,		// 決済通知用CGI
		'free1' => $arrData["order_id"],				// マーチャント購入ID
		'free2' => "",
		'free3' => "",
		'free_csv' => "",
		'request_date' => $now_time,					// リクエスト日時(YYYYMMDDHHMMSS)
		'limit_second' => "600"							// リクエスト許容時間
	);

	// チェックサム生成
	$sps_hashcode = createCheckSum($arrData, $arrOrderDetail,$arrSendData, $arrInfo);

	$rowno = 1;
	foreach( $arrOrderDetail as $row => $col ){
		// 税込み価格
		$tax_in = SC_Utils_Ex::sfCalcIncTax($col['price'], $arrInfo['tax'], $arrInfo['tax_rule'] );
		// 税額
		$tax = $tax_in - $col['price'];
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_rowno[]\" value=\"".$rowno."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_id[]\" value=\"".$col['product_id']."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_name[]\" value=\"".LC_Util_SPS::convNgChar($col['product_name'])."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_count[]\" value=\"".$col['quantity']."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_tax[]\" value=\"".$tax."\">\n";
		$html .= "\t\t<input type=\"hidden\" name=\"dtl_amount[]\" value=\"".$tax_in * $col['quantity']."\">\n";

		$rowno++;
	}

	// 送料
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_rowno[]\" value=\"".$rowno."\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_id[]\" value=\"no-code\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_name[]\" value=\"送料\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_item_count[]\" value=\"1\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_tax[]\" value=\"0\">\n";
	$html .= "\t\t<input type=\"hidden\" name=\"dtl_amount[]\" value=\"".$arrData['deliv_fee']."\">\n";

    // ハッシュ
	$html .= "\t\t<input type=\"hidden\" name=\"sps_hashcode\" value=\"".$sps_hashcode."\">\n";

	// データ送信先CGI 携帯端末の場合は 携帯用に飛ばす
	$objPage->order_url = $order_url;
	$objPage->arrSendData = $arrSendData;
	$objPage->html = $html;
	$objPage->tpl_mainpage = MDL_SPS_TEMPLATE_PATH.'card_mobile.tpl';
	$objPage->payment_method = $arrPayment[0]['payment_method'];
	return;
}

// チェックサム生成
function createCheckSum($arrData, $arrOrderDetail, $arrSendData, $arrInfo) {

	// ポストパラメータ
	foreach ($arrSendData as $key => $val) {
		if ($key != "request_date" && $key != "limit_second") {
			$joinParam .= trim($val);
		}
	}

	// 明細パラメータ
	$rowno = 1;
	foreach( $arrOrderDetail as $row => $col ){
		// 税込み価格
		$tax_in = SC_Utils_Ex::sfCalcIncTax($col['price'], $arrInfo['tax'], $arrInfo['tax_rule'] );
		// 税額
		$tax_temp = $tax_in - $col['price'];
		// パラメータ生成
		$joinParam .= $rowno.
		              $col['product_id'].
		              LC_Util_SPS::convNgChar($col['product_name']).
		              $col['quantity'].
		              $tax_temp.
		              $tax_in * $col['quantity'];
		$rowno++;
	}

	// 送料パラメータ
	$joinParam .= $rowno. "no-code". "送料". "1". "0". $arrData['deliv_fee'];

	// SPS払出ハッシュキー
	$objSPS =& LC_Mdl_SPS::getInstance();
	$key_for_checksum = $objSPS->getUserSettings('id_sps_hash');

	// リクエスト日時/リクエスト許容時間/SPS払出ハッシュキー
	$joinParam .= $arrSendData['request_date']. $arrSendData['limit_second']. $key_for_checksum;

	// モバイルは全角ｶﾅを半角ｶﾅへ変換
    if (SC_MobileUserAgent::isMobile()) {
        $joinParam = mb_convert_kana($joinParam, 'k');
    }

	//ハッシュコード算出
	$sps_hashcode = sha1($joinParam);

	return $sps_hashcode;
}

