<?php
/*
 * Copyright(c) 2011 SOFTBANK PAYMENT SERVICE Corp. All rights reserved.
 * http://www.sbpayment.jp/
 * Copyright(c) 2011 Spirit of Co.,Ltd. All rights reserved.
 * http://www.spiritof.jp/
 */

if( file_exists(MODULE_REALDIR . 'mdl_sps/inc/include.php') === TRUE ) {
    require_once(MODULE_REALDIR . 'mdl_sps/inc/include.php');
}

class mdl_sps extends SC_Helper_Plugin_Ex {

    function mdl_sps() {
        $this->plugin_name = MDL_SPS_CODE;
        $this->plugin_realdir = DATA_REALDIR . 'plugin/' . MDL_SPS_CODE . '/';
    }

    function preProcess(&$objPage){
        $class_name = get_class($objPage);
        switch ($class_name) {
            case 'LC_Page_Admin_Order_Edit_Ex':
                $this->lfPreProcessAdminOrderEdit($objPage);
                break;

        default:
        }
    }

    function process(&$objPage) {
        $class_name = get_class($objPage);
        switch ($class_name) {
            case 'LC_Page_Admin_Order_Edit_Ex':
                $this->lfProcessAdminOrderEdit($objPage);
                break;
        default:
        }
    }

    function isEnable($class_name) {
        $arrEnableClass = array('LC_Page_Admin_Order_Edit_Ex');
        return in_array($class_name, $arrEnableClass);
    }

    function lfPreProcessAdminOrderEdit(&$objPage) {
        $objDate = new SC_Date_Ex();
        $objDate->setStartYear(RELEASE_YEAR);
        $objPage->arrYear = $objDate->getYear();
        $objPage->arrMonth = $objDate->getMonth();
        $objPage->arrDay = $objDate->getDay();
    }

    function lfProcessAdminOrderEdit(&$objPage) {
        // テンプレート書き換え
        if($objPage->arrForm['order_id']['value'] != "") {
            $order_id = $objPage->arrForm['order_id']['value'];
            $payment_id = $objPage->arrForm['payment_id']['value'];
            if(!SC_Utils_Ex::isBlank($order_id)
                    and !SC_Utils_Ex::isBlank($payment_id)
                    and SC_Utils_Ex::sfIsInt($order_id)
                    and SC_Utils_Ex::sfIsInt($payment_id)) {
                //決済モジュール情報取得
                $objQuery =& SC_Query_Ex::getSingletonInstance();
                $arrPaymentData = $objQuery->getRow('module_code, memo03', 'dtb_payment', 'payment_id = ?', array($payment_id));
                if( file_exists( $this->plugin_realdir . 'edit.tpl' )
                        and $arrPaymentData['module_code'] == MDL_SPS_CODE
                        and ( $arrPaymentData['memo03'] == SPS_CREDIT
                                or $arrPaymentData['memo03'] == SPS_CREDIT3D
                                or $arrPaymentData['memo03'] == SPS_YWALLET )
                        ) {
                    $objPage->mdl_sps_payment_type = $arrPaymentData['memo03'];
                    $objPage->tpl_mainpage = $this->plugin_realdir . 'edit.tpl';
                }
                //受注内決済情報取得
                $arrPayOrderData = $objQuery->getRow('memo03, memo05', 'dtb_order', 'order_id = ?', array($order_id));
                $objPage->mdl_sps_order_memo03 = $arrPayOrderData['memo03'];
                $objPage->mdl_sps_order_memo05 = $arrPayOrderData['memo05'];
            }
        }
        // リクエスト実行
        if($objPage->getMode() == 'sps_request') {
            $objErr = new SC_CheckError_Ex($_POST);
            $objErr->doFunc(array("年","sps_year"), array('EXIST_CHECK', 'NUM_CHECK'));
            $objErr->doFunc(array("月","sps_month"), array('EXIST_CHECK', 'NUM_CHECK'));
            $objErr->doFunc(array("日","sps_date"), array('EXIST_CHECK', 'NUM_CHECK'));
            $objErr->doFunc(array("売上・返金日", "sps_year", "sps_month", "sps_date"), array("CHECK_DATE"));
            if($objErr->arrErr) {
                $objPage->arrErr = $objErr->arrErr;
            }else{
                require_once(MODULE_REALDIR . 'mdl_sps/request.php');
                $objPage->sps_return = sfSpsRequest($order_id, $_POST['request_type'] );
            }
            // 再読込実行
            $_POST['mode'] = 'pre_edit';
            $objPage->action();
            // 変更された値を再読込
            $order_id = $objPage->arrForm['order_id']['value'];
            $objQuery =& SC_Query_Ex::getSingletonInstance();
            $arrPayOrderData = $objQuery->getRow('memo03, memo05', 'dtb_order', 'order_id = ?', array($order_id));
            $objPage->mdl_sps_order_memo03 = $arrPayOrderData['memo03'];
            $objPage->mdl_sps_order_memo05 = $arrPayOrderData['memo05'];
        }
        // 日付の再セット
        if($_POST['sps_year'] != "") {
            $objPage->arrForm['sps_year']['value'] = $_POST['sps_year'];
        }else{
            $objPage->arrForm['sps_year']['value'] = date('Y');
        }
        if($_POST['sps_month'] != "") {
            $objPage->arrForm['sps_month']['value'] = $_POST['sps_month'];
        }else{
            $objPage->arrForm['sps_month']['value'] = date('n');
        }
        if($_POST['sps_date'] != "") {
            $objPage->arrForm['sps_date']['value'] = $_POST['sps_date'];
        }else{
            $objPage->arrForm['sps_date']['value'] = date('j');
        }
    }
}
?>
