<?php
/*
 * SPSからの決済結果レスポンスを受け取り
 * 結果画面を表示する
 *
 */
// POST SJIS ERROR 対策
foreach($_POST as $key => $val) {
    $_POST[$key] = mb_convert_encoding($val, "UTF-8", "SJIS");
}

require_once( '../require.php' );
require_once( MODULE_REALDIR . 'mdl_sps/inc/include.php' );
require_once(CLASS_EX_REALDIR . "page_extends/LC_Page_Ex.php");

class LC_Page_Mdl_SPS_Complete extends LC_Page_Ex {
    /**
     * Page を初期化する.
     *
     * @return void
     */
    function init() {
        parent::init();
        $this->tpl_title = "ソフトバンクペイメントサービス決済";
	}

    /**
     * Page のプロセス.
     *
     * @return void
     */
    function process() {
		parent::process();
        $this->action();
        $this->sendResponse();
    }

    /**
     * Page のアクション.
     *
     * @return void
     */
    function action() {
        $objView = new SC_SiteView();
        $objSiteInfo = $objView->objSiteInfo;
        $this->arrInfo = $objSiteInfo->data;
		$objLayout = new SC_Helper_PageLayout_Ex();
		
        switch($this->objDisplay->detectDevice()) {
        case DEVICE_TYPE_MOBILE:
			$objLayout->sfGetPageLayout($this, false, 'shopping/complete.php', DEVICE_TYPE_MOBILE);
            $this->tpl_mainpage = MDL_SPS_TEMPLATE_PATH . 'sps_complete_mobile.tpl';
			break;
        case DEVICE_TYPE_SMARTPHONE:
			$objLayout->sfGetPageLayout($this, false, 'shopping/complete.php', DEVICE_TYPE_SMARTPHONE);
            $this->tpl_mainpage = MDL_SPS_TEMPLATE_PATH . 'sps_complete_sphone.tpl';
			break;
        case DEVICE_TYPE_PC:
		default:
			$objLayout->sfGetPageLayout($this, false, 'shopping/complete.php',DEVICE_TYPE_PC);
            $this->tpl_mainpage = MDL_SPS_TEMPLATE_PATH . 'sps_complete.tpl';

        }

		// レスポンスパラメータで表示を切り替える
		if( $_GET['success'] == TRUE ){
		    $this->dispParam = 'success';
		}
		else if( $_GET['cancel'] == TRUE ){
		    $this->dispParam = 'cancel';
		}
		else if( $_GET['error'] == TRUE ){
		    $this->dispParam = 'error';
		}
    }

    /**
     * デストラクタ.
     *
     * @return void
     */
    function destroy() {
        parent::destroy();
    }
    /**
     * トークンチェックしない.
     */
    function doValidToken() {
        // nothing.
    }
}

// }}}
// {{{ generate page

$objPage = new LC_Page_Mdl_SPS_Complete();
register_shutdown_function(array($objPage, "destroy"));
$objPage->init();
$objPage->process();

?>
