<?php
/**
 * @copyright 2011 SOFTBANK PAYMENT SERVICE Corp. All Rights Reserved.
 * @copyright 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 * @link http://www.sbpayment.jp/
 *
 */
// 3Dセキュアクレジット使用判定＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊
define('USE_CREDIT3D', false); // 3Dセキュアクレジットをご利用になる場合は本稿をtrueに変更して下さい。
// ＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊
//
// 決済種別使用判定＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊
// 2.11.x では当面API決済は使えません。(指定日売上でのAPI利用のみ)
define('USE_SETTLEMENT', false); //API決済種別をご利用になる場合は本項を true に変更してください。
// ＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊

define('MDL_SPS', true);
define('MDL_SPS_VERSION', '2.1.0');
define('MDL_SPS_PATH', MODULE_REALDIR.'mdl_sps/');
define('MDL_SPS_CLASS_PATH', MDL_SPS_PATH.'class/');
define('MDL_SPS_MODULE_PATH', MDL_SPS_PATH.'module/');
define('MDL_SPS_TEMPLATE_PATH', MDL_SPS_PATH.'templates/');

define("MDL_SPS_CODE", 'mdl_sps');

// 決済種別
define("SETTLEMENT_LINK", 1);
define("SETTLEMENT_API", 2);

// 利用する決済サービス
define("SPS_CREDIT", 1);   // クレジット
define("SPS_CONVENI", 2);  // ウェブコンビニ
define("SPS_PAYEASY", 3);  // ペイジー
define("SPS_WEBMONEY", 4); // ウェブマネー
define("SPS_YWALLET", 5);  // Y!ウォレット
define("SPS_CREDIT3D", 6);

// 非会員時の顧客IDプレフィクス
define('NON_MEMBER_PREFIX', 'reg_sps');

define("COMPLETE_URL", HTTPS_URL . "user_data/sps_complete.php"); // 決済結果URL
define("SUCCESS_URL", COMPLETE_URL."?success=true");            // 正常完了時
define("CANCEL_URL", COMPLETE_URL."?cancel=true");              // キャンセル時
define("ERROR_URL", COMPLETE_URL."?error=true");                // エラー時

// 決済通知先
define("MDL_SPS_SETTLEMENT_URL", HTTPS_URL . 'user_data/sps_recv.php');

// リクエストコード（クレジット）
define("SPS_CREDIT_AUTH_CODE", "ST01-00101-101");       // リアル与信
define("SPS_CREDIT_COMMIT_CODE", "ST02-00101-101");     // コミット
define("SPS_CREDIT_DATECOMMIT_CODE", "ST02-00201-101"); // 売上指定要求
define("SPS_CREDIT_CANCEL_CODE", "ST02-00303-101");     // 取消（返金）

// リクエストコード（Y!ウォレット）
define("SPS_YWALLET_CANCEL_CODE", "ST02-00303-304");    // 取消（返金）

// リクエストタイプ
define("SPS_REQUEST_TYPE_COMMIT", "commit");          // 確定要求
define("SPS_REQUEST_TYPE_DATECOMMIT", "date_commit"); // 売上指定要求
define("SPS_REQUEST_TYPE_CANCEL", "cancel");          // 返金要求

// リクエスト結果 【dtb_orderのmemo05へ登録】
define("SPS_COMMIT_OK", 1);     // 確定
define("SPS_CANCEL_OK", 2);     // 取消（返金）
define("SPS_ERROR", 3);         // 通信失敗
define("SPS_DATECOMMIT_OK", 4); // 確定

// 売上計上設定
define("SPS_AUTH_DATE_COMMIT", 0); // 売上日指定要求(与信のみ)
define("SPS_AUTH_AUTO", 1);        // 自動売上

// クレジット支払回数
define("SPS_CREDIT_PAYMENT_TYPE_L", 10); // 一括
//define("SPS_CREDIT_PAYMENT_TYPE_BL", 21); // ボーナス一括
//define("SPS_CREDIT_PAYMENT_TYPE_BB", 34); // ボーナス併用
//define("SPS_CREDIT_PAYMENT_TYPE_D", 61); // 分割
//define("SPS_CREDIT_PAYMENT_TYPE_R", 80); // リボ

//禁止文字 置き換え
//define("SPS_NG_CHAR", "?\???￠￢");
define("SPS_REPLACE_NG_CHAR", '　');

require_once( MDL_SPS_CLASS_PATH . 'util/LC_Util_SPS.php' );

